@echo off

rem ---------------------------------------------------------------------------
rem   .gpx-Datei erstellen, welche eine .hgt-Datei umrahmt.
rem
rem   Der Name der .hgt-Datei wird entweder als %1 bergeben oder abgefragt.
rem   Als %2 kann ein Verzeichnisname fr die .gpx bergeben werden.
rem   In der Mitte wird ein Wegpunkt mit dem Namen der .hgt-Datei erzeugt.
rem   %1 und %2 sind fr das Script "all_hgt2gpx.bat" vorgesehen.
rem
rem   peter@danninger.eu                                        07.06.2021
rem ---------------------------------------------------------------------------


set hgtname=%1
set gpxdir=%2

if "%hgtname%" EQU "" (
  echo.
  echo .gpx-Datei erstellen, welche eine .hgt-Datei umrahmt
  echo In der Mitte wird ein Wegpunkt mit dem Namen der .hgt-Datei erzeugt.
  echo.
  set /p hgtname="Namen der .hgt-Datei eingeben: "
) else (
  if "%gpxdir%" EQU "" (
    rem echo .gpx im lokalen Verzeichnis abspeichern && pause
  ) else (
    mkdir %gpxdir% >nul 2>nul
  )
)

set hgttyp=%hgtname:~7%
if /i %hgttyp% NEQ .hgt (
  echo ungueltiger hgt-Dateityp: %hgttyp%
  pause
  exit /b 0
)

echo %hgtname%
  
set latdir=%hgtname:~0,1%
set latval=%hgtname:~1,2%
set latval1=%hgtname:~1,1%
set latval2=%hgtname:~2,1%
set londir=%hgtname:~3,1%
set lonval=%hgtname:~4,3%
set lonval1=%hgtname:~4,1%
set lonval2=%hgtname:~5,1%
set lonval3=%hgtname:~6,1%
set lonval4=%hgtname:~5,2%

if %latval1% EQU 0 (
  set latval=%latval2%
)

set latfrom=%latval%
if /i %latdir% EQU N (
  set /a latto=%latfrom%+1
  set latwp=%latfrom%
) else if /i %latdir% EQU S (
  if %latfrom% EQU 0 (
    echo ungueltiger lat Wert: S00
    pause
    exit /b 0
  )
  set /a latto=%latfrom%-1
  set /a latwp=%latfrom%-1
) else (
  echo ungueltiger lat Typ ^(N/S^): %latdir%
  pause
  exit /b 0
)

rem ----- eigentlich nicht erforderlich -----
  if %latfrom% LSS 10 (
    set latfrom=0%latfrom%
  )
  if %latto% LSS 10 (
    set latto=0%latto%
  )
  if %latwp% LSS 10 (
    set latwp=0%latwp%
  )

if /i %latdir% EQU S (
  if %latfrom% NEQ 0 (
    set latfrom=-%latfrom%
  )
  if %latto% NEQ 0 (
    set latto=-%latto%
  )
  set latwp=-%latwp%
)
set latwp=%latwp%.5

if "%1" EQU "" (
  echo latfrom= %latfrom%
  echo latto= %latto%
  echo latwp= %latwp%
)

if %lonval1% EQU 0 (
  if %lonval2% EQU 0 (
    set lonval=%lonval3%
  ) else (
    set lonval=%lonval4%
  )
)

set /a lonfrom=%lonval%
if /i %londir% EQU E (
  set /a lonto=%lonfrom%+1
  set lonwp=%lonfrom%
) else if /i %londir% EQU W (
  if %lonfrom% EQU 0 (
    echo ungueltiger lon Wert: W000
    pause
    exit /b 0
  )
  set /a lonto=%lonfrom%-1
  set /a lonwp=%lonfrom%-1
) else (
  echo ungueltiger lon Typ ^(E/W^): %londir%
  pause
  exit /b 0
)

rem ----- eigentlich nicht erforderlich -----
  if %lonfrom% LSS 10 (
    set lonfrom=00%lonfrom%
  ) else if %lonfrom% LSS 100 (
    set lonfrom=0%lonfrom%
  )
  if %lonto% LSS 10 (
    set lonto=00%lonto%
  ) else if %lonto% LSS 100 (
    set lonto=0%lonto%
  )
  if %lonwp% LSS 10 (
    set lonwp=00%lonwp%
  ) else if %lonwp% LSS 100 (
    set lonwp=0%lonwp%
  )

if /i %londir% EQU W (
  if %lonfrom% NEQ 0 (
    set lonfrom=-%lonfrom%
  )
  if %lonto% NEQ 0 (
    set lonto=-%lonto%
  )
  set lonwp=-%lonwp%
)

set lonwp=%lonwp%.5

if "%1" EQU "" (
  echo lonfrom= %lonfrom%
  echo lonto= %lonto%
  echo lonwp= %lonwp%
)

set gpxname=%hgtname:~0,7%.gpx
set gpxname=%gpxname:n=N%
set gpxname=%gpxname:s=S%
set gpxname=%gpxname:w=W%
set gpxname=%gpxname:e=E%

if "%gpxdir%" NEQ "" (
  rem echo gpxdir: %gpxdir%
  set gpxname=%gpxdir%\%gpxname%
)

echo ^<?xml version=^"1.0^" encoding=^"utf-8^"?^> > %gpxname%
echo ^<gpx  creator=^"hgt2gpx.bat (peter@danninger.eu, 07.06.2021)^" >> %gpxname%
echo       version=^"1.1^" >> %gpxname%
echo       xmlns=^"http://www.topografix.com/GPX/1/1^" >> %gpxname%
echo       xmlns:xsi=^"http://www.w3.org/2001/XMLSchema-instance^" >> %gpxname%
echo       xsi:schemaLocation=^" >> %gpxname%
echo         http://www.topografix.com/GPX/1/1                   https://www.topografix.com/GPX/1/1/gpx.xsd >> %gpxname%
echo         http://www.garmin.com/xmlschemas/GpxExtensions/v3   https://www8.garmin.com/xmlschemas/GpxExtensionsv3.xsd >> %gpxname%
echo       ^" >> %gpxname%
echo       xmlns:gpxx=^"http://www.garmin.com/xmlschemas/GpxExtensions/v3^" >> %gpxname%
echo       xmlns:gpxtrx=^"http://www.garmin.com/xmlschemas/GpxExtensions/v3^" >> %gpxname%
echo ^> >> %gpxname%
echo   ^<wpt lat="%latwp%" lon="%lonwp%"^> >> %gpxname%
echo     ^<name^>%hgtname%^</name^> >> %gpxname%
echo     ^<sym^>flag, red^</sym^> >> %gpxname%
echo   ^</wpt^> >> %gpxname%
echo   ^<trk^> >> %gpxname%
echo     ^<name^>%gpxname%^</name^> >> %gpxname%
echo     ^<cmt^>Rahmen fuer %hgtname%^</cmt^> >> %gpxname%
echo     ^<extensions^> >> %gpxname%
echo       ^<gpxx:TrackExtension^> >> %gpxname%
echo         ^<gpxx:DisplayColor^>Magenta^</gpxx:DisplayColor^> >> %gpxname%
echo       ^</gpxx:TrackExtension^> >> %gpxname%
echo     ^</extensions^> >> %gpxname%
echo     ^<trkseg^> >> %gpxname%
echo       ^<trkpt lat=^"%latto%^" lon=^"%lonfrom%^"^>^</trkpt^> >> %gpxname%
echo       ^<trkpt lat=^"%latto%^" lon=^"%lonto%^"^>^</trkpt^> >> %gpxname%
echo       ^<trkpt lat=^"%latfrom%^" lon=^"%lonto%^"^>^</trkpt^> >> %gpxname%
echo       ^<trkpt lat=^"%latfrom%^" lon=^"%lonfrom%^"^>^</trkpt^> >> %gpxname%
echo       ^<trkpt lat=^"%latto%^" lon=^"%lonfrom%^"^>^</trkpt^> >> %gpxname%
echo     ^</trkseg^> >> %gpxname%
echo   ^</trk^> >> %gpxname%
echo ^</gpx^> >> %gpxname%

if "%1" EQU "" (
  echo -------------------------------------------------
  type %gpxname%
  echo -------------------------------------------------
  pause
)

exit /b 0
